Gecode::Int::Rel::LexNq< VX, VY > Class Template Reference
Other available functionality » Integer propagators

Lexical disequality propagator. More...

`#include <rel.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &x, ViewArray< VY > &y)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

ExecStatus | resubscribe (Space &home, RelTest rt, VX &x0, VY &y0, VX x1, VY y1)
| Update subscription.
| LexNq (Home home, ViewArray< VX > &x, ViewArray< VY > &y)
| Constructor for posting.
| LexNq (Space &home, LexNq< VX, VY > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

VX | x0
| View currently subscribed to.
VY | y0
| View currently subscribed to.
VX | x1
| View currently subscribed to.
VY | y1
| View currently subscribed to.
ViewArray< VX > | x
| Views not yet subscribed to.
ViewArray< VY > | y
| Views not yet subscribed to.

## Detailed Description

template<class VX, class VY>
class Gecode::Int::Rel::LexNq< VX, VY >

Lexical disequality propagator.

Requires

#include <gecode/int/rel.hh>
rel.hh

Definition at line 657 of file rel.hh.

## Constructor & Destructor Documentation

## LexNq() [1/2]

template<class VX, class VY>

Gecode::Int::Rel::LexNq< VX, VY >::LexNq | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | ViewArray< VY > & | y )

inline protected

Constructor for posting.

Definition at line 266 of file lex.hpp.

## LexNq() [2/2]

template<class VX, class VY>

Gecode::Int::Rel::LexNq< VX, VY >::LexNq | ( | Space & | home,
|  | LexNq< VX, VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 296 of file lex.hpp.

## Member Function Documentation

## resubscribe()

template<class VX, class VY>

ExecStatus Gecode::Int::Rel::LexNq< VX, VY >::resubscribe | ( | Space & | home,
|  | RelTest | rt,
|  | VX & | x0,
|  | VY & | y0,
|  | VX | x1,
|  | VY | y1 )

inline protected

Update subscription.

Definition at line 376 of file lex.hpp.

## copy()

template<class VX, class VY>

Actor * Gecode::Int::Rel::LexNq< VX, VY >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 305 of file lex.hpp.

## cost()

template<class VX, class VY>

PropCost Gecode::Int::Rel::LexNq< VX, VY >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

Implements Gecode::Propagator.

Definition at line 281 of file lex.hpp.

## reschedule()

template<class VX, class VY>

void Gecode::Int::Rel::LexNq< VX, VY >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 287 of file lex.hpp.

## propagate()

template<class VX, class VY>

ExecStatus Gecode::Int::Rel::LexNq< VX, VY >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 409 of file lex.hpp.

## post()

template<class VX, class VY>

ExecStatus Gecode::Int::Rel::LexNq< VX, VY >::post | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | ViewArray< VY > & | y )

inline static

Post propagator .

Definition at line 332 of file lex.hpp.

## dispose()

template<class VX, class VY>

size_t Gecode::Int::Rel::LexNq< VX, VY >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 367 of file lex.hpp.

## Member Data Documentation

## x0

template<class VX, class VY>

VX Gecode::Int::Rel::LexNq< VX, VY >::x0

protected

View currently subscribed to.

Definition at line 660 of file rel.hh.

## y0

template<class VX, class VY>

VY Gecode::Int::Rel::LexNq< VX, VY >::y0

protected

View currently subscribed to.

Definition at line 662 of file rel.hh.

## x1

template<class VX, class VY>

VX Gecode::Int::Rel::LexNq< VX, VY >::x1

protected

View currently subscribed to.

Definition at line 664 of file rel.hh.

## y1

template<class VX, class VY>

VY Gecode::Int::Rel::LexNq< VX, VY >::y1

protected

View currently subscribed to.

Definition at line 666 of file rel.hh.

## x

template<class VX, class VY>

ViewArray<VX> Gecode::Int::Rel::LexNq< VX, VY >::x

protected

Views not yet subscribed to.

Definition at line 668 of file rel.hh.

## y

template<class VX, class VY>

ViewArray<VY> Gecode::Int::Rel::LexNq< VX, VY >::y

protected

Views not yet subscribed to.

Definition at line 670 of file rel.hh.

The documentation for this class was generated from the following files:

- gecode/int/rel.hh
- gecode/int/rel/lex.hpp